org.apache.fontbox.cff

## Class Type1CharString

- java.lang.Object
- - org.apache.fontbox.cff.Type1CharString

Direct Known Subclasses:
  Type2CharString

    public class Type1CharString
    extends Object

This class represents and renders a Type 1 CharString.

Author:
  Villu Ruusmann, John Hewson

### Constructor Summary

Constructors
`protected` `Type1CharString(Type1CharStringReader font, String fontName, String glyphName)` Constructor for use in subclasses.
`` `Type1CharString(Type1CharStringReader font, String fontName, String glyphName, List<Object> sequence)` Constructs a new Type1CharString object.

### Method Summary

All Methods Instance Methods Concrete Methods
`protected void` `addCommand(List<Number> numbers, CharStringCommand command)` Add a command to the type1 sequence.
`Rectangle2D` `getBounds()` Returns the bounds of the renderer path.
`protected Object` `getLastSequenceEntry()` Returns the last entry of the underlying type1 sequence.
`String` `getName()`
`GeneralPath` `getPath()` Returns the path of the character.
`int` `getWidth()` Returns the advance width of the glyph.
`protected boolean` `isSequenceEmpty()` Indicates if the underlying type1 sequence is empty.
`String` `toString()`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### Type1CharString

    public Type1CharString(Type1CharStringReader font,
                           String fontName,
                           String glyphName,
                           List<Object> sequence)

Constructs a new Type1CharString object.

Parameters:
  `font` - Parent Type 1 CharString font.
  `fontName` - Name of the font.
  `glyphName` - Name of the glyph.
  `sequence` - Type 1 char string sequence

#### Type1CharString

    protected Type1CharString(Type1CharStringReader font,
                              String fontName,
                              String glyphName)

Constructor for use in subclasses.

Parameters:
  `font` - Parent Type 1 CharString font.
  `fontName` - Name of the font.
  `glyphName` - Name of the glyph.

### Method Detail

#### getName

    public String getName()

#### getBounds

    public Rectangle2D getBounds()

Returns the bounds of the renderer path.

Returns:
  the bounds as Rectangle2D

#### getWidth

    public int getWidth()

Returns the advance width of the glyph.

Returns:
  the width

#### getPath

    public GeneralPath getPath()

Returns the path of the character.

Returns:
  the path

#### addCommand

    protected void addCommand(List<Number> numbers,
                              CharStringCommand command)

Add a command to the type1 sequence.

Parameters:
  `numbers` - the parameters of the command to be added
  `command` - the command to be added

#### isSequenceEmpty

    protected boolean isSequenceEmpty()

Indicates if the underlying type1 sequence is empty.

Returns:
  true if the sequence is empty

#### getLastSequenceEntry

    protected Object getLastSequenceEntry()

Returns the last entry of the underlying type1 sequence.

Returns:
  the last entry of the type 1 sequence or null if empty

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`